﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Sample145862;
using MVCSampleBrowser.Models;
using Syncfusion.JavaScript.DataSources;
using System.Collections;
using Syncfusion.JavaScript;
using Syncfusion.Linq;
using System.Web.Script.Serialization;
using System.Net;
namespace Sample145862.Controllers
{
    public class GridController : Controller
    {
        //
        // GET: /Grid/
       // List<ParentItem> parent = new List<ParentItem>();

        public ActionResult GridFeatures()
        {
            var DataSource = new NorthwindDataContext().EmployeeViews.Take(9).ToList();
            ViewBag.datasource = DataSource;
            return View();
           // var DataSource = OrderRepository.GetAllRecords();
            //ViewBag.datasource = DataSource;
           
           // return View();
        }

        public ActionResult DataSource(DataManager dm)
        {
            IEnumerable Data = OrderRepository.GetAllRecords();
            Syncfusion.JavaScript.DataSources.DataOperations operation = new Syncfusion.JavaScript.DataSources.DataOperations();
            
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                //HttpContext.Response.AddHeader("Exception", "Our Exception message");//add exception message to the response header
               // Response.StatusCode = 404;
                Data = operation.PerformSorting(Data, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                Data = operation.PerformWhereFilter(Data, dm.Where, dm.Where[0].Operator);
            }
            int count = Data.AsQueryable().Count();
            if (dm.Skip != 0)
            {
                Data = operation.PerformSkip(Data, dm.Skip);
            }
            if (dm.Take != 0)
            {
                Data = operation.PerformTake(Data, dm.Take);
            }
            return Json(new { result = Data, count = count }, JsonRequestBehavior.AllowGet);
        }
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
        }
        public ActionResult Insert(EditableOrder value)
        {
            if (!ModelState.IsValid) //if validation got failed
            {
                var message = string.Join(" | ", ModelState.Values
                .SelectMany(v => v.Errors)
               .Select(e => e.ErrorMessage));
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest, message);//message returns the exception content 
            }
            OrderRepository.Add(value);
            return Json(value, JsonRequestBehavior.AllowGet); 
        }

        public ActionResult Update(EditableOrder value)
        {
           // HttpContext.Response.AddHeader("Exception", "Our Exception message");//add exception message to the response header
           // Response.StatusCode = 404; 
            if (value.OrderID > 300) // check some condition and process update action 
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest, "Data is not valid"); //message returns the exception content 
            return Json(value, JsonRequestBehavior.AllowGet); 
        }
        // [HttpPost]
        //public ActionResult CellEditDelete(int key)
        //{
            
        //   throw new Exception("Don't do this again");
           
        //}

     }
}
